#ifndef EMBEDDINGENGINE_H
#define EMBEDDINGENGINE_H

#include<vector>
#include<string>
#include"aiengineerror.h"

namespace ai_engine{
namespace lm {
namespace embedding{


class AbstractEmbeddingEngine{
public:
    virtual ~AbstractEmbeddingEngine();
    virtual std::string aiengineName() = 0;
    virtual bool isCloud() = 0;

    enum class EmbeddingDataType { Text = 0, Base64Image};

    enum class EmbeddingModel { TextModel = 0, ImageModel};

    virtual std::vector<float> embedding(
        EmbeddingModel model,
        const std::vector<unsigned char>& input,
        EmbeddingDataType inputType,
        ai_engine::lm::EngineError &error) = 0;


};



} // namespace embedding
} // namespace lm
} // namespace ai_engine


#endif // EMBEDDINGENGINE_H

